/* THIS FILE IS AUTOGENERATED FROM SVGPathElement.webidl BY Codegen.py - DO NOT EDIT */

#include "DOMSVGPathSeg.h"
#include "DOMSVGPathSegList.h"
#include "SVGGraphicsElementBinding.h"
#include "SVGPathElementBinding.h"
#include "WrapperFactory.h"
#include "mozilla/FloatingPoint.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/SVGAnimatedNumber.h"
#include "mozilla/dom/SVGPathElement.h"
#include "mozilla/dom/XrayExpandoClass.h"
#include "nsISVGPoint.h"

namespace mozilla {
namespace dom {

namespace SVGPathElementBinding {

static_assert(IsRefcounted<NativeType>::value == IsRefcounted<SVGGraphicsElementBinding::NativeType>::value,
              "Can't inherit from an interface with a different ownership model.");

static bool
get_pathLength(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, JSJitGetterCallArgs args)
{
  auto result(StrongOrRawPtr<mozilla::dom::SVGAnimatedNumber>(self->PathLength()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo pathLength_getterinfo = {
  { (JSJitGetterOp)get_pathLength },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasNone, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  true,  /* isMovable.  Not relevant for setters. */
  true, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
getTotalLength(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  float result(self->GetTotalLength());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().set(JS_NumberValue(double(result)));
  return true;
}

static const JSJitInfo getTotalLength_methodinfo = {
  { (JSJitGetterOp)getTotalLength },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
getPointAtLength(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.getPointAtLength");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.getPointAtLength");
    return false;
  }
  binding_detail::FastErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::nsISVGPoint>(self->GetPointAtLength(arg0, rv)));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo getPointAtLength_methodinfo = {
  { (JSJitGetterOp)getPointAtLength },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
getPathSegAtLength(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.getPathSegAtLength");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.getPathSegAtLength");
    return false;
  }
  uint32_t result(self->GetPathSegAtLength(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setNumber(result);
  return true;
}

static const JSJitInfo getPathSegAtLength_methodinfo = {
  { (JSJitGetterOp)getPathSegAtLength },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegClosePath(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegClosePath>(self->CreateSVGPathSegClosePath()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegClosePath_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegClosePath },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegMovetoAbs(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegMovetoAbs");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegMovetoAbs");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegMovetoAbs");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegMovetoAbs>(self->CreateSVGPathSegMovetoAbs(arg0, arg1)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegMovetoAbs_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegMovetoAbs },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegMovetoRel(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegMovetoRel");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegMovetoRel");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegMovetoRel");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegMovetoRel>(self->CreateSVGPathSegMovetoRel(arg0, arg1)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegMovetoRel_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegMovetoRel },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegLinetoAbs(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegLinetoAbs");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegLinetoAbs");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegLinetoAbs");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegLinetoAbs>(self->CreateSVGPathSegLinetoAbs(arg0, arg1)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegLinetoAbs_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegLinetoAbs },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegLinetoRel(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegLinetoRel");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegLinetoRel");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegLinetoRel");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegLinetoRel>(self->CreateSVGPathSegLinetoRel(arg0, arg1)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegLinetoRel_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegLinetoRel },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegCurvetoCubicAbs(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 6)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegCurvetoCubicAbs");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegCurvetoCubicAbs");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegCurvetoCubicAbs");
    return false;
  }
  float arg2;
  if (!ValueToPrimitive<float, eDefault>(cx, args[2], &arg2)) {
    return false;
  } else if (!mozilla::IsFinite(arg2)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 3 of SVGPathElement.createSVGPathSegCurvetoCubicAbs");
    return false;
  }
  float arg3;
  if (!ValueToPrimitive<float, eDefault>(cx, args[3], &arg3)) {
    return false;
  } else if (!mozilla::IsFinite(arg3)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 4 of SVGPathElement.createSVGPathSegCurvetoCubicAbs");
    return false;
  }
  float arg4;
  if (!ValueToPrimitive<float, eDefault>(cx, args[4], &arg4)) {
    return false;
  } else if (!mozilla::IsFinite(arg4)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 5 of SVGPathElement.createSVGPathSegCurvetoCubicAbs");
    return false;
  }
  float arg5;
  if (!ValueToPrimitive<float, eDefault>(cx, args[5], &arg5)) {
    return false;
  } else if (!mozilla::IsFinite(arg5)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 6 of SVGPathElement.createSVGPathSegCurvetoCubicAbs");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegCurvetoCubicAbs>(self->CreateSVGPathSegCurvetoCubicAbs(arg0, arg1, arg2, arg3, arg4, arg5)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegCurvetoCubicAbs_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegCurvetoCubicAbs },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegCurvetoCubicRel(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 6)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegCurvetoCubicRel");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegCurvetoCubicRel");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegCurvetoCubicRel");
    return false;
  }
  float arg2;
  if (!ValueToPrimitive<float, eDefault>(cx, args[2], &arg2)) {
    return false;
  } else if (!mozilla::IsFinite(arg2)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 3 of SVGPathElement.createSVGPathSegCurvetoCubicRel");
    return false;
  }
  float arg3;
  if (!ValueToPrimitive<float, eDefault>(cx, args[3], &arg3)) {
    return false;
  } else if (!mozilla::IsFinite(arg3)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 4 of SVGPathElement.createSVGPathSegCurvetoCubicRel");
    return false;
  }
  float arg4;
  if (!ValueToPrimitive<float, eDefault>(cx, args[4], &arg4)) {
    return false;
  } else if (!mozilla::IsFinite(arg4)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 5 of SVGPathElement.createSVGPathSegCurvetoCubicRel");
    return false;
  }
  float arg5;
  if (!ValueToPrimitive<float, eDefault>(cx, args[5], &arg5)) {
    return false;
  } else if (!mozilla::IsFinite(arg5)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 6 of SVGPathElement.createSVGPathSegCurvetoCubicRel");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegCurvetoCubicRel>(self->CreateSVGPathSegCurvetoCubicRel(arg0, arg1, arg2, arg3, arg4, arg5)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegCurvetoCubicRel_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegCurvetoCubicRel },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegCurvetoQuadraticAbs(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 4)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegCurvetoQuadraticAbs");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegCurvetoQuadraticAbs");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegCurvetoQuadraticAbs");
    return false;
  }
  float arg2;
  if (!ValueToPrimitive<float, eDefault>(cx, args[2], &arg2)) {
    return false;
  } else if (!mozilla::IsFinite(arg2)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 3 of SVGPathElement.createSVGPathSegCurvetoQuadraticAbs");
    return false;
  }
  float arg3;
  if (!ValueToPrimitive<float, eDefault>(cx, args[3], &arg3)) {
    return false;
  } else if (!mozilla::IsFinite(arg3)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 4 of SVGPathElement.createSVGPathSegCurvetoQuadraticAbs");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegCurvetoQuadraticAbs>(self->CreateSVGPathSegCurvetoQuadraticAbs(arg0, arg1, arg2, arg3)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegCurvetoQuadraticAbs_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegCurvetoQuadraticAbs },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegCurvetoQuadraticRel(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 4)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegCurvetoQuadraticRel");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegCurvetoQuadraticRel");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegCurvetoQuadraticRel");
    return false;
  }
  float arg2;
  if (!ValueToPrimitive<float, eDefault>(cx, args[2], &arg2)) {
    return false;
  } else if (!mozilla::IsFinite(arg2)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 3 of SVGPathElement.createSVGPathSegCurvetoQuadraticRel");
    return false;
  }
  float arg3;
  if (!ValueToPrimitive<float, eDefault>(cx, args[3], &arg3)) {
    return false;
  } else if (!mozilla::IsFinite(arg3)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 4 of SVGPathElement.createSVGPathSegCurvetoQuadraticRel");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegCurvetoQuadraticRel>(self->CreateSVGPathSegCurvetoQuadraticRel(arg0, arg1, arg2, arg3)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegCurvetoQuadraticRel_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegCurvetoQuadraticRel },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegArcAbs(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 7)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegArcAbs");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegArcAbs");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegArcAbs");
    return false;
  }
  float arg2;
  if (!ValueToPrimitive<float, eDefault>(cx, args[2], &arg2)) {
    return false;
  } else if (!mozilla::IsFinite(arg2)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 3 of SVGPathElement.createSVGPathSegArcAbs");
    return false;
  }
  float arg3;
  if (!ValueToPrimitive<float, eDefault>(cx, args[3], &arg3)) {
    return false;
  } else if (!mozilla::IsFinite(arg3)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 4 of SVGPathElement.createSVGPathSegArcAbs");
    return false;
  }
  float arg4;
  if (!ValueToPrimitive<float, eDefault>(cx, args[4], &arg4)) {
    return false;
  } else if (!mozilla::IsFinite(arg4)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 5 of SVGPathElement.createSVGPathSegArcAbs");
    return false;
  }
  bool arg5;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[5], &arg5)) {
    return false;
  }
  bool arg6;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[6], &arg6)) {
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegArcAbs>(self->CreateSVGPathSegArcAbs(arg0, arg1, arg2, arg3, arg4, arg5, arg6)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegArcAbs_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegArcAbs },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegArcRel(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 7)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegArcRel");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegArcRel");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegArcRel");
    return false;
  }
  float arg2;
  if (!ValueToPrimitive<float, eDefault>(cx, args[2], &arg2)) {
    return false;
  } else if (!mozilla::IsFinite(arg2)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 3 of SVGPathElement.createSVGPathSegArcRel");
    return false;
  }
  float arg3;
  if (!ValueToPrimitive<float, eDefault>(cx, args[3], &arg3)) {
    return false;
  } else if (!mozilla::IsFinite(arg3)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 4 of SVGPathElement.createSVGPathSegArcRel");
    return false;
  }
  float arg4;
  if (!ValueToPrimitive<float, eDefault>(cx, args[4], &arg4)) {
    return false;
  } else if (!mozilla::IsFinite(arg4)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 5 of SVGPathElement.createSVGPathSegArcRel");
    return false;
  }
  bool arg5;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[5], &arg5)) {
    return false;
  }
  bool arg6;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[6], &arg6)) {
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegArcRel>(self->CreateSVGPathSegArcRel(arg0, arg1, arg2, arg3, arg4, arg5, arg6)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegArcRel_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegArcRel },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegLinetoHorizontalAbs(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegLinetoHorizontalAbs");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegLinetoHorizontalAbs");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegLinetoHorizontalAbs>(self->CreateSVGPathSegLinetoHorizontalAbs(arg0)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegLinetoHorizontalAbs_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegLinetoHorizontalAbs },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegLinetoHorizontalRel(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegLinetoHorizontalRel");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegLinetoHorizontalRel");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegLinetoHorizontalRel>(self->CreateSVGPathSegLinetoHorizontalRel(arg0)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegLinetoHorizontalRel_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegLinetoHorizontalRel },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegLinetoVerticalAbs(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegLinetoVerticalAbs");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegLinetoVerticalAbs");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegLinetoVerticalAbs>(self->CreateSVGPathSegLinetoVerticalAbs(arg0)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegLinetoVerticalAbs_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegLinetoVerticalAbs },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegLinetoVerticalRel(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegLinetoVerticalRel");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegLinetoVerticalRel");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegLinetoVerticalRel>(self->CreateSVGPathSegLinetoVerticalRel(arg0)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegLinetoVerticalRel_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegLinetoVerticalRel },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegCurvetoCubicSmoothAbs(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 4)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegCurvetoCubicSmoothAbs");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegCurvetoCubicSmoothAbs");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegCurvetoCubicSmoothAbs");
    return false;
  }
  float arg2;
  if (!ValueToPrimitive<float, eDefault>(cx, args[2], &arg2)) {
    return false;
  } else if (!mozilla::IsFinite(arg2)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 3 of SVGPathElement.createSVGPathSegCurvetoCubicSmoothAbs");
    return false;
  }
  float arg3;
  if (!ValueToPrimitive<float, eDefault>(cx, args[3], &arg3)) {
    return false;
  } else if (!mozilla::IsFinite(arg3)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 4 of SVGPathElement.createSVGPathSegCurvetoCubicSmoothAbs");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegCurvetoCubicSmoothAbs>(self->CreateSVGPathSegCurvetoCubicSmoothAbs(arg0, arg1, arg2, arg3)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegCurvetoCubicSmoothAbs_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegCurvetoCubicSmoothAbs },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegCurvetoCubicSmoothRel(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 4)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegCurvetoCubicSmoothRel");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegCurvetoCubicSmoothRel");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegCurvetoCubicSmoothRel");
    return false;
  }
  float arg2;
  if (!ValueToPrimitive<float, eDefault>(cx, args[2], &arg2)) {
    return false;
  } else if (!mozilla::IsFinite(arg2)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 3 of SVGPathElement.createSVGPathSegCurvetoCubicSmoothRel");
    return false;
  }
  float arg3;
  if (!ValueToPrimitive<float, eDefault>(cx, args[3], &arg3)) {
    return false;
  } else if (!mozilla::IsFinite(arg3)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 4 of SVGPathElement.createSVGPathSegCurvetoCubicSmoothRel");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegCurvetoCubicSmoothRel>(self->CreateSVGPathSegCurvetoCubicSmoothRel(arg0, arg1, arg2, arg3)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegCurvetoCubicSmoothRel_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegCurvetoCubicSmoothRel },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegCurvetoQuadraticSmoothAbs(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegCurvetoQuadraticSmoothAbs");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegCurvetoQuadraticSmoothAbs");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegCurvetoQuadraticSmoothAbs");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegCurvetoQuadraticSmoothAbs>(self->CreateSVGPathSegCurvetoQuadraticSmoothAbs(arg0, arg1)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegCurvetoQuadraticSmoothAbs_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegCurvetoQuadraticSmoothAbs },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
createSVGPathSegCurvetoQuadraticSmoothRel(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 2)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "SVGPathElement.createSVGPathSegCurvetoQuadraticSmoothRel");
  }
  float arg0;
  if (!ValueToPrimitive<float, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of SVGPathElement.createSVGPathSegCurvetoQuadraticSmoothRel");
    return false;
  }
  float arg1;
  if (!ValueToPrimitive<float, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of SVGPathElement.createSVGPathSegCurvetoQuadraticSmoothRel");
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegCurvetoQuadraticSmoothRel>(self->CreateSVGPathSegCurvetoQuadraticSmoothRel(arg0, arg1)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo createSVGPathSegCurvetoQuadraticSmoothRel_methodinfo = {
  { (JSJitGetterOp)createSVGPathSegCurvetoQuadraticSmoothRel },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
get_pathSegList(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, JSJitGetterCallArgs args)
{
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegList>(self->PathSegList()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo pathSegList_getterinfo = {
  { (JSJitGetterOp)get_pathSegList },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
get_animatedPathSegList(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::SVGPathElement* self, JSJitGetterCallArgs args)
{
  auto result(StrongOrRawPtr<mozilla::DOMSVGPathSegList>(self->AnimatedPathSegList()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo animatedPathSegList_getterinfo = {
  { (JSJitGetterOp)get_animatedPathSegList },
  { prototypes::id::SVGPathElement },
  { PrototypeTraits<prototypes::id::SVGPathElement>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::dom::SVGPathElement* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::SVGPathElement>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::SVGPathElement* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::SVGPathElement>(obj);
  if (self) {
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::SVGPathElement>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::SVGPathElement* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::SVGPathElement>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("getTotalLength", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getTotalLength_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getPointAtLength", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getPointAtLength_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getPathSegAtLength", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getPathSegAtLength_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegClosePath", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegClosePath_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegMovetoAbs", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegMovetoAbs_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegMovetoRel", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegMovetoRel_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegLinetoAbs", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegLinetoAbs_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegLinetoRel", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegLinetoRel_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegCurvetoCubicAbs", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegCurvetoCubicAbs_methodinfo), 6, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegCurvetoCubicRel", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegCurvetoCubicRel_methodinfo), 6, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegCurvetoQuadraticAbs", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegCurvetoQuadraticAbs_methodinfo), 4, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegCurvetoQuadraticRel", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegCurvetoQuadraticRel_methodinfo), 4, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegArcAbs", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegArcAbs_methodinfo), 7, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegArcRel", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegArcRel_methodinfo), 7, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegLinetoHorizontalAbs", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegLinetoHorizontalAbs_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegLinetoHorizontalRel", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegLinetoHorizontalRel_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegLinetoVerticalAbs", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegLinetoVerticalAbs_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegLinetoVerticalRel", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegLinetoVerticalRel_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegCurvetoCubicSmoothAbs", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegCurvetoCubicSmoothAbs_methodinfo), 4, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegCurvetoCubicSmoothRel", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegCurvetoCubicSmoothRel_methodinfo), 4, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegCurvetoQuadraticSmoothAbs", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegCurvetoQuadraticSmoothAbs_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("createSVGPathSegCurvetoQuadraticSmoothRel", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&createSVGPathSegCurvetoQuadraticSmoothRel_methodinfo), 2, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};


// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { nullptr, &sMethods_specs[0] },
  { nullptr, nullptr }
};

static jsid sMethods_ids[23];

static const JSPropertySpec sAttributes_specs[] = {
  { "pathLength", JSPROP_SHARED | JSPROP_ENUMERATE, { { { { GenericBindingGetter, &pathLength_getterinfo } }, JSNATIVE_WRAPPER(nullptr) } } },
  { "pathSegList", JSPROP_SHARED | JSPROP_ENUMERATE, { { { { GenericBindingGetter, &pathSegList_getterinfo } }, JSNATIVE_WRAPPER(nullptr) } } },
  { "animatedPathSegList", JSPROP_SHARED | JSPROP_ENUMERATE, { { { { GenericBindingGetter, &animatedPathSegList_getterinfo } }, JSNATIVE_WRAPPER(nullptr) } } },
  JS_PS_END
};


// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sAttributes[] = {
  { nullptr, &sAttributes_specs[0] },
  { nullptr, nullptr }
};

static jsid sAttributes_ids[4];


static const NativePropertiesN<2> sNativeProperties = {
  -1,
  false, 0,
  false, 0,
  true,  0 /* sMethods */,
  true,  1 /* sAttributes */,
  false, 0,
  false, 0,
  false, 0,
  {
    { sMethods, sMethods_ids, sMethods_specs },
    { sAttributes, sAttributes_ids, sAttributes_specs }
  }
};

static const DOMIfaceAndProtoJSClass sInterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    &sBoringInterfaceObjectClassClassOps,
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    &sInterfaceObjectClassObjectOps
  },
  eInterface,
  true,
  prototypes::id::SVGPathElement,
  PrototypeTraits<prototypes::id::SVGPathElement>::Depth,
  sNativePropertyHooks,
  "function SVGPathElement() {\n    [native code]\n}",
  SVGGraphicsElementBinding::GetConstructorObject
};

static const DOMIfaceAndProtoJSClass sPrototypeClass = {
  {
    "SVGPathElementPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    JS_NULL_CLASS_OPS,
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  false,
  prototypes::id::SVGPathElement,
  PrototypeTraits<prototypes::id::SVGPathElement>::Depth,
  sNativePropertyHooks,
  "[object SVGPathElementPrototype]",
  SVGGraphicsElementBinding::GetProtoObject
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aDefineOnGlobal);
}

static const js::ClassOps sClassOps = {
  _addProperty, /* addProperty */
  nullptr,               /* delProperty */
  nullptr,               /* getProperty */
  nullptr,               /* setProperty */
  nullptr, /* enumerate */
  nullptr, /* resolve */
  nullptr, /* mayResolve */
  _finalize, /* finalize */
  nullptr, /* call */
  nullptr,               /* hasInstance */
  nullptr,               /* construct */
  nullptr, /* trace */
};

static const js::ClassExtension sClassExtension = {
  nullptr, /* weakmapKeyDelegateOp */
  _objectMoved /* objectMovedOp */
};

static const DOMJSClass sClass = {
  { "SVGPathElement",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_FOREGROUND_FINALIZE | JSCLASS_HAS_RESERVED_SLOTS(1),
    &sClassOps,
    JS_NULL_CLASS_SPEC,
    &sClassExtension,
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::EventTarget, prototypes::id::Node, prototypes::id::Element, prototypes::id::SVGElement, prototypes::id::SVGGraphicsElement, prototypes::id::SVGPathElement, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::SVGPathElement >::value,
  sNativePropertyHooks,
  FindAssociatedGlobalForNative<mozilla::dom::SVGPathElement>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::SVGPathElement>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return sClass.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::dom::SVGPathElement* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::dom::SVGPathElement*>(aObject) ==
             reinterpret_cast<mozilla::dom::SVGPathElement*>(aObject),
             "Multiple inheritance for mozilla::dom::SVGPathElement is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::SVGGraphicsElement*>(aObject) ==
             reinterpret_cast<mozilla::dom::SVGGraphicsElement*>(aObject),
             "Multiple inheritance for mozilla::dom::SVGGraphicsElement is broken.");
  MOZ_ASSERT(static_cast<nsSVGElement*>(aObject) ==
             reinterpret_cast<nsSVGElement*>(aObject),
             "Multiple inheritance for nsSVGElement is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::Element*>(aObject) ==
             reinterpret_cast<mozilla::dom::Element*>(aObject),
             "Multiple inheritance for mozilla::dom::Element is broken.");
  MOZ_ASSERT(static_cast<nsINode*>(aObject) ==
             reinterpret_cast<nsINode*>(aObject),
             "Multiple inheritance for nsINode is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::EventTarget*>(aObject) ==
             reinterpret_cast<mozilla::dom::EventTarget*>(aObject),
             "Multiple inheritance for mozilla::dom::EventTarget is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> global(aCx, FindAssociatedGlobal(aCx, aObject->GetParentObject()));
  if (!global) {
    return false;
  }
  MOZ_ASSERT(JS_IsGlobalObject(global));
  MOZ_ASSERT(!JS::ObjectIsMarkedGray(global));

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
#ifdef DEBUG
    binding_detail::AssertReflectorHasGivenProto(aCx, aReflector, aGivenProto);
#endif // DEBUG
    return true;
  }

  JSAutoCompartment ac(aCx, global);
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    // Unfortunately, while aGivenProto was in the compartment of aCx
    // coming in, we changed compartments to that of "parent" so may need
    // to wrap the proto here.
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::dom::SVGPathElement> creator(aCx);
  creator.CreateObject(aCx, sClass.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();

  MOZ_ASSERT(aCache->GetWrapperPreserveColor() &&
             aCache->GetWrapperPreserveColor() == aReflector);
  // If proto != canonicalProto, we have to preserve our wrapper;
  // otherwise we won't be able to properly recreate it later, since
  // we won't know what proto to use.  Note that we don't check
  // aGivenProto here, since it's entirely possible (and even
  // somewhat common) to have a non-null aGivenProto which is the
  // same as canonicalProto.
  if (proto != canonicalProto) {
    PreserveWrapper(aObject);
  }

  return true;
}

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  nullptr,
  { sNativeProperties.Upcast(), nullptr },
  prototypes::id::SVGPathElement,
  constructors::id::SVGPathElement,
  SVGGraphicsElementBinding::sNativePropertyHooks,
  &DefaultXrayExpandoObjectClass
} };

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Handle<JSObject*> parentProto(SVGGraphicsElementBinding::GetProtoObjectHandle(aCx));
  if (!parentProto) {
    return;
  }

  JS::Handle<JSObject*> constructorProto(SVGGraphicsElementBinding::GetConstructorObjectHandle(aCx));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sAttributes, sAttributes_ids)) {
      return;
    }
    sIdsInited = true;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::SVGPathElement);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::SVGPathElement);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &sPrototypeClass.mBase, protoCache,
                              constructorProto, &sInterfaceObjectClass.mBase, 0, nullptr,
                              interfaceCache,
                              sNativeProperties.Upcast(),
                              nullptr,
                              "SVGPathElement", aDefineOnGlobal,
                              nullptr,
                              false);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  JSObject* global = JS::CurrentGlobalOrNull(aCx);
  if (!(js::GetObjectClass(global)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(global);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::SVGPathElement)) {
    JS::Rooted<JSObject*> rootedGlobal(aCx, global);
    CreateInterfaceObjects(aCx, rootedGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   *
   * Calling address() avoids the read read barrier that does gray
   * unmarking, but it's not possible for the object to be gray here.
   */

  const JS::Heap<JSObject*>& entrySlot = protoAndIfaceCache.EntrySlotMustExist(prototypes::id::SVGPathElement);
  MOZ_ASSERT_IF(entrySlot, !JS::ObjectIsMarkedGray(entrySlot));
  return JS::Handle<JSObject*>::fromMarkedLocation(entrySlot.address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  JSObject* global = JS::CurrentGlobalOrNull(aCx);
  if (!(js::GetObjectClass(global)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(global);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::SVGPathElement)) {
    JS::Rooted<JSObject*> rootedGlobal(aCx, global);
    CreateInterfaceObjects(aCx, rootedGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   *
   * Calling address() avoids the read read barrier that does gray
   * unmarking, but it's not possible for the object to be gray here.
   */

  const JS::Heap<JSObject*>& entrySlot = protoAndIfaceCache.EntrySlotMustExist(constructors::id::SVGPathElement);
  MOZ_ASSERT_IF(entrySlot, !JS::ObjectIsMarkedGray(entrySlot));
  return JS::Handle<JSObject*>::fromMarkedLocation(entrySlot.address());
}

JSObject*
GetConstructorObject(JSContext* aCx)
{
  return GetConstructorObjectHandle(aCx);
}

} // namespace SVGPathElementBinding



} // namespace dom
} // namespace mozilla
