//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PPresentationParent_h
#define PPresentationParent_h

#include "mozilla/dom/PPresentation.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/dom/ipc/IdType.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PPresentationRequestParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PPresentationRequestChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PPresentationBuilderParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PPresentationBuilderChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PPresentationRequestParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PPresentationBuilderParent;
} // namespace dom
} // namespace mozilla

namespace IPC {
class Principal;
} // namespace IPC

namespace mozilla {
namespace dom {


class PPresentationParent :
    public mozilla::ipc::IProtocol
{
    friend class mozilla::dom::PContentParent;

    friend class mozilla::dom::PPresentationRequestParent;

    friend class mozilla::dom::PPresentationBuilderParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::BufferedInputStreamParams BufferedInputStreamParams;
    typedef mozilla::dom::BuildTransportRequest BuildTransportRequest;
    typedef mozilla::dom::CloseSessionRequest CloseSessionRequest;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::FileInputStreamParams FileInputStreamParams;
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef mozilla::ipc::MIMEInputStreamParams MIMEInputStreamParams;
    typedef mozilla::ipc::MultiplexInputStreamParams MultiplexInputStreamParams;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::ipc::PartialFileInputStreamParams PartialFileInputStreamParams;
    typedef mozilla::dom::PresentationIPCRequest PresentationIPCRequest;
    typedef IPC::Principal Principal;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolFdMapping ProtocolFdMapping;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::dom::ReconnectSessionRequest ReconnectSessionRequest;
    typedef mozilla::ipc::RemoteInputStreamParams RemoteInputStreamParams;
    typedef mozilla::ipc::SameProcessInputStreamParams SameProcessInputStreamParams;
    typedef mozilla::dom::SendSessionMessageRequest SendSessionMessageRequest;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::StartSessionRequest StartSessionRequest;
    typedef mozilla::ipc::StringInputStreamParams StringInputStreamParams;
    typedef mozilla::dom::TabId TabId;
    typedef mozilla::ipc::TemporaryFileInputStreamParams TemporaryFileInputStreamParams;
    typedef mozilla::dom::TerminateSessionRequest TerminateSessionRequest;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PPresentationRequestParent PPresentationRequestParent;
    typedef mozilla::dom::PPresentationRequestChild PPresentationRequestChild;
    typedef mozilla::dom::PPresentationBuilderParent PPresentationBuilderParent;
    typedef mozilla::dom::PPresentationBuilderChild PPresentationBuilderChild;

    typedef PPresentation::State State;

    virtual bool
    Recv__delete__();
    virtual bool
    RecvRegisterAvailabilityHandler(nsTArray<nsString>&& aAvailabilityUrls) = 0;
    virtual bool
    RecvUnregisterAvailabilityHandler(nsTArray<nsString>&& aAvailabilityUrls) = 0;
    virtual bool
    RecvRegisterSessionHandler(
            const nsString& aSessionId,
            const uint8_t& aRole) = 0;
    virtual bool
    RecvUnregisterSessionHandler(
            const nsString& aSessionId,
            const uint8_t& aRole) = 0;
    virtual bool
    RecvRegisterRespondingHandler(const uint64_t& aWindowId) = 0;
    virtual bool
    RecvUnregisterRespondingHandler(const uint64_t& aWindowId) = 0;
    virtual bool
    RecvPPresentationRequestConstructor(
            PPresentationRequestParent* actor,
            const PresentationIPCRequest& aRequest);
    virtual bool
    RecvNotifyReceiverReady(
            const nsString& aSessionId,
            const uint64_t& aWindowId,
            const bool& aIsLoading) = 0;
    virtual bool
    RecvNotifyTransportClosed(
            const nsString& aSessionId,
            const uint8_t& aRole,
            const nsresult& aReason) = 0;
    virtual PPresentationBuilderParent*
    AllocPPresentationBuilderParent(
            const nsString& aSessionId,
            const uint8_t& aRole) = 0;
    virtual bool
    DeallocPPresentationBuilderParent(PPresentationBuilderParent* aActor) = 0;
    virtual PPresentationRequestParent*
    AllocPPresentationRequestParent(const PresentationIPCRequest& aRequest) = 0;
    virtual bool
    DeallocPPresentationRequestParent(PPresentationRequestParent* aActor) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PPresentationParent();

    virtual ~PPresentationParent();

    PContentParent*
    Manager() const;

    void
    ManagedPPresentationBuilderParent(nsTArray<PPresentationBuilderParent*>& aArr) const;
    const ManagedContainer<PPresentationBuilderParent>&
    ManagedPPresentationBuilderParent() const;

    void
    ManagedPPresentationRequestParent(nsTArray<PPresentationRequestParent*>& aArr) const;
    const ManagedContainer<PPresentationRequestParent>&
    ManagedPPresentationRequestParent() const;

    PPresentation::State
    state();

    MOZ_MUST_USE bool
    SendNotifyAvailableChange(
            const nsTArray<nsString>& aAvailabilityUrls,
            const bool& aAvailable);

    MOZ_MUST_USE bool
    SendNotifySessionStateChange(
            const nsString& aSessionId,
            const uint16_t& aState,
            const nsresult& aReason);

    MOZ_MUST_USE bool
    SendNotifyMessage(
            const nsString& aSessionId,
            const nsCString& aData,
            const bool& aIsBinary);

    MOZ_MUST_USE bool
    SendNotifySessionConnect(
            const uint64_t& aWindowId,
            const nsString& aSessionId);

    MOZ_MUST_USE bool
    SendNotifyCloseSessionTransport(
            const nsString& aSessionId,
            const uint8_t& aRole,
            const nsresult& aReason);

    MOZ_MUST_USE PPresentationBuilderParent*
    SendPPresentationBuilderConstructor(
            const nsString& aSessionId,
            const uint8_t& aRole);

    MOZ_MUST_USE PPresentationBuilderParent*
    SendPPresentationBuilderConstructor(
            PPresentationBuilderParent* actor,
            const nsString& aSessionId,
            const uint8_t& aRole);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PPresentationRequestParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PPresentationRequestParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const CloseSessionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            CloseSessionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const SendSessionMessageRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            SendSessionMessageRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PPresentationBuilderParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PPresentationBuilderParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const StartSessionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            StartSessionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const TerminateSessionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            TerminateSessionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const ReconnectSessionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            ReconnectSessionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const BuildTransportRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            BuildTransportRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PPresentationParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PPresentationParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const PresentationIPCRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            PresentationIPCRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
    ManagedContainer<PPresentationBuilderParent> mManagedPPresentationBuilderParent;
    ManagedContainer<PPresentationRequestParent> mManagedPPresentationRequestParent;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class PresentationParent :
    public PPresentationParent
{
    virtual bool
    RecvRegisterAvailabilityHandler(nsTArray<nsString>&& aAvailabilityUrls);

    virtual bool
    RecvUnregisterAvailabilityHandler(nsTArray<nsString>&& aAvailabilityUrls);

    virtual bool
    RecvRegisterSessionHandler(
            const nsString& aSessionId,
            const uint8_t& aRole);

    virtual bool
    RecvUnregisterSessionHandler(
            const nsString& aSessionId,
            const uint8_t& aRole);

    virtual bool
    RecvRegisterRespondingHandler(const uint64_t& aWindowId);

    virtual bool
    RecvUnregisterRespondingHandler(const uint64_t& aWindowId);

    virtual bool
    RecvNotifyReceiverReady(
            const nsString& aSessionId,
            const uint64_t& aWindowId,
            const bool& aIsLoading);

    virtual bool
    RecvNotifyTransportClosed(
            const nsString& aSessionId,
            const uint8_t& aRole,
            const nsresult& aReason);

    virtual PPresentationBuilderParent*
    AllocPPresentationBuilderParent(
            const nsString& aSessionId,
            const uint8_t& aRole);

    virtual bool
    DeallocPPresentationBuilderParent(PPresentationBuilderParent* aActor);

    virtual PPresentationRequestParent*
    AllocPPresentationRequestParent(const PresentationIPCRequest& aRequest);

    virtual bool
    DeallocPPresentationRequestParent(PPresentationRequestParent* aActor);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT PresentationParent();
    virtual ~PresentationParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
bool
PresentationParent::RecvRegisterAvailabilityHandler(nsTArray<nsString>&& aAvailabilityUrls)
{
    return false;
}

bool
PresentationParent::RecvUnregisterAvailabilityHandler(nsTArray<nsString>&& aAvailabilityUrls)
{
    return false;
}

bool
PresentationParent::RecvRegisterSessionHandler(
        const nsString& aSessionId,
        const uint8_t& aRole)
{
    return false;
}

bool
PresentationParent::RecvUnregisterSessionHandler(
        const nsString& aSessionId,
        const uint8_t& aRole)
{
    return false;
}

bool
PresentationParent::RecvRegisterRespondingHandler(const uint64_t& aWindowId)
{
    return false;
}

bool
PresentationParent::RecvUnregisterRespondingHandler(const uint64_t& aWindowId)
{
    return false;
}

bool
PresentationParent::RecvNotifyReceiverReady(
        const nsString& aSessionId,
        const uint64_t& aWindowId,
        const bool& aIsLoading)
{
    return false;
}

bool
PresentationParent::RecvNotifyTransportClosed(
        const nsString& aSessionId,
        const uint8_t& aRole,
        const nsresult& aReason)
{
    return false;
}

PPresentationBuilderParent*
PresentationParent::AllocPPresentationBuilderParent(
        const nsString& aSessionId,
        const uint8_t& aRole)
{
    return 0;
}

bool
PresentationParent::DeallocPPresentationBuilderParent(PPresentationBuilderParent* aActor)
{
    return false;
}

PPresentationRequestParent*
PresentationParent::AllocPPresentationRequestParent(const PresentationIPCRequest& aRequest)
{
    return 0;
}

bool
PresentationParent::DeallocPPresentationRequestParent(PPresentationRequestParent* aActor)
{
    return false;
}

void
PresentationParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT PresentationParent::PresentationParent()
{
    MOZ_COUNT_CTOR(PresentationParent);
}

MOZ_IMPLICIT PresentationParent::~PresentationParent()
{
    MOZ_COUNT_DTOR(PresentationParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PPresentationParent_h
