//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PStorageChild_h
#define PStorageChild_h

#include "mozilla/dom/PStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class PStorageChild :
    public mozilla::ipc::IProtocol
{
    friend class mozilla::dom::PContentChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PContentParent PContentParent;

    typedef PStorage::State State;

    virtual bool
    RecvObserve(
            const nsCString& topic,
            const nsString& originAttributesPattern,
            const nsCString& originScope) = 0;
    virtual bool
    RecvOriginsHavingData(nsTArray<nsCString>&& origins) = 0;
    virtual bool
    RecvLoadItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value) = 0;
    virtual bool
    RecvLoadDone(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsresult& rv) = 0;
    virtual bool
    RecvLoadUsage(
            const nsCString& scope,
            const int64_t& usage) = 0;
    virtual bool
    RecvError(const nsresult& rv) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PStorageChild();

    virtual ~PStorageChild();

    PContentChild*
    Manager() const;

    PStorage::State
    state();

    static bool
    Send__delete__(PStorageChild* actor);

    bool
    SendPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const uint32_t& alreadyLoadedCount,
            nsTArray<nsString>* keys,
            nsTArray<nsString>* values,
            nsresult* rv);

    bool
    SendAsyncPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const bool& priority);

    bool
    SendAsyncGetUsage(const nsCString& scope);

    bool
    SendAsyncAddItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value);

    bool
    SendAsyncUpdateItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value);

    bool
    SendAsyncRemoveItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key);

    bool
    SendAsyncClear(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix);

    bool
    SendAsyncFlush();

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PStorageChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PStorageChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class StorageChild :
    public PStorageChild
{
    virtual bool
    RecvObserve(
            const nsCString& topic,
            const nsString& originAttributesPattern,
            const nsCString& originScope);

    virtual bool
    RecvOriginsHavingData(nsTArray<nsCString>&& origins);

    virtual bool
    RecvLoadItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value);

    virtual bool
    RecvLoadDone(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsresult& rv);

    virtual bool
    RecvLoadUsage(
            const nsCString& scope,
            const int64_t& usage);

    virtual bool
    RecvError(const nsresult& rv);

    MOZ_IMPLICIT StorageChild();
    virtual ~StorageChild();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
bool
StorageChild::RecvObserve(
        const nsCString& topic,
        const nsString& originAttributesPattern,
        const nsCString& originScope)
{
    return false;
}

bool
StorageChild::RecvOriginsHavingData(nsTArray<nsCString>&& origins)
{
    return false;
}

bool
StorageChild::RecvLoadItem(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const nsString& key,
        const nsString& value)
{
    return false;
}

bool
StorageChild::RecvLoadDone(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const nsresult& rv)
{
    return false;
}

bool
StorageChild::RecvLoadUsage(
        const nsCString& scope,
        const int64_t& usage)
{
    return false;
}

bool
StorageChild::RecvError(const nsresult& rv)
{
    return false;
}

MOZ_IMPLICIT StorageChild::StorageChild()
{
    MOZ_COUNT_CTOR(StorageChild);
}

MOZ_IMPLICIT StorageChild::~StorageChild()
{
    MOZ_COUNT_DTOR(StorageChild);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PStorageChild_h
