//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PQuota_h
#define PQuota_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "mozilla/dom/quota/PersistenceType.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct AllUsageParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class AllUsageParams final
{
private:

public:
    MOZ_IMPLICIT AllUsageParams();

    MOZ_IMPLICIT AllUsageParams(const bool& _getAll)
    {
        Init();
        Assign(_getAll);
    }

    MOZ_IMPLICIT AllUsageParams(const AllUsageParams& _o)
    {
        Init();
        Assign((_o).getAll());
    }

    ~AllUsageParams();

    void
    operator=(const AllUsageParams& _o)
    {
        Assign((_o).getAll());
    }

    bool
    operator==(const AllUsageParams& _o) const;

    bool&
    getAll()
    {
        return getAll_;
    }
    const bool&
    getAll() const
    {
        return getAll_;
    }

private:
    void
    Init();

    void
    Assign(const bool& _getAll);

    bool getAll_;
};
} // namespace quota
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OriginUsageParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class OriginUsageParams final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT OriginUsageParams();

    MOZ_IMPLICIT OriginUsageParams(
            const PrincipalInfo& _principalInfo,
            const bool& _getGroupUsage)
    {
        Init();
        Assign(_principalInfo, _getGroupUsage);
    }

    MOZ_IMPLICIT OriginUsageParams(const OriginUsageParams& _o)
    {
        Init();
        Assign((_o).principalInfo(), (_o).getGroupUsage());
    }

    ~OriginUsageParams();

    void
    operator=(const OriginUsageParams& _o)
    {
        Assign((_o).principalInfo(), (_o).getGroupUsage());
    }

    bool
    operator==(const OriginUsageParams& _o) const;

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    bool&
    getGroupUsage()
    {
        return getGroupUsage_;
    }
    const bool&
    getGroupUsage() const
    {
        return getGroupUsage_;
    }

private:
    void
    Init();

    void
    Assign(
            const PrincipalInfo& _principalInfo,
            const bool& _getGroupUsage);

    PrincipalInfo principalInfo_;
    bool getGroupUsage_;
};
} // namespace quota
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace quota {
class AllUsageParams;
} // namespace quota
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace quota {
class OriginUsageParams;
} // namespace quota
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union UsageRequestParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class UsageRequestParams final
{
public:
    enum Type {
        T__None,
        TAllUsageParams = 1,
        TOriginUsageParams,
        T__Last = TOriginUsageParams
    };

private:
    typedef mozilla::dom::quota::AllUsageParams AllUsageParams;
    typedef mozilla::dom::quota::OriginUsageParams OriginUsageParams;
    typedef AllUsageParams AllUsageParams__tdef;
    typedef OriginUsageParams OriginUsageParams__tdef;

    union Value {
        mozilla::AlignedStorage2<AllUsageParams> VAllUsageParams;
        mozilla::AlignedStorage2<OriginUsageParams> VOriginUsageParams;
    };

    AllUsageParams*
    ptr_AllUsageParams()
    {
        return ((mValue).VAllUsageParams).addr();
    }
    const AllUsageParams*
    constptr_AllUsageParams() const
    {
        return ((mValue).VAllUsageParams).addr();
    }
    OriginUsageParams*
    ptr_OriginUsageParams()
    {
        return ((mValue).VOriginUsageParams).addr();
    }
    const OriginUsageParams*
    constptr_OriginUsageParams() const
    {
        return ((mValue).VOriginUsageParams).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT UsageRequestParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT UsageRequestParams(const AllUsageParams& aOther);

    MOZ_IMPLICIT UsageRequestParams(const OriginUsageParams& aOther);

    MOZ_IMPLICIT UsageRequestParams(const UsageRequestParams& aOther);

    ~UsageRequestParams();

    Type
    type() const
    {
        return mType;
    }

    UsageRequestParams&
    operator=(const AllUsageParams& aRhs);

    UsageRequestParams&
    operator=(const OriginUsageParams& aRhs);

    UsageRequestParams&
    operator=(const UsageRequestParams& aRhs);

    bool
    operator==(const AllUsageParams& aRhs) const;

    bool
    operator==(const OriginUsageParams& aRhs) const;

    bool
    operator==(const UsageRequestParams& aRhs) const;

    AllUsageParams&
    get_AllUsageParams()
    {
        AssertSanity(TAllUsageParams);
        return (*(ptr_AllUsageParams()));
    }
    const AllUsageParams&
    get_AllUsageParams() const
    {
        AssertSanity(TAllUsageParams);
        return (*(constptr_AllUsageParams()));
    }
    void
    get(AllUsageParams* aOutValue) const;
    operator AllUsageParams&()
    {
        return get_AllUsageParams();
    }
    operator const AllUsageParams&() const
    {
        return get_AllUsageParams();
    }

    OriginUsageParams&
    get_OriginUsageParams()
    {
        AssertSanity(TOriginUsageParams);
        return (*(ptr_OriginUsageParams()));
    }
    const OriginUsageParams&
    get_OriginUsageParams() const
    {
        AssertSanity(TOriginUsageParams);
        return (*(constptr_OriginUsageParams()));
    }
    void
    get(OriginUsageParams* aOutValue) const;
    operator OriginUsageParams&()
    {
        return get_OriginUsageParams();
    }
    operator const OriginUsageParams&() const
    {
        return get_OriginUsageParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace quota
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClearOriginParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class ClearOriginParams final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::dom::quota::PersistenceType PersistenceType;

public:
    MOZ_IMPLICIT ClearOriginParams();

    MOZ_IMPLICIT ClearOriginParams(
            const PrincipalInfo& _principalInfo,
            const PersistenceType& _persistenceType,
            const bool& _persistenceTypeIsExplicit,
            const bool& _clearAll)
    {
        Init();
        Assign(_principalInfo, _persistenceType, _persistenceTypeIsExplicit, _clearAll);
    }

    MOZ_IMPLICIT ClearOriginParams(const ClearOriginParams& _o)
    {
        Init();
        Assign((_o).principalInfo(), (_o).persistenceType(), (_o).persistenceTypeIsExplicit(), (_o).clearAll());
    }

    ~ClearOriginParams();

    void
    operator=(const ClearOriginParams& _o)
    {
        Assign((_o).principalInfo(), (_o).persistenceType(), (_o).persistenceTypeIsExplicit(), (_o).clearAll());
    }

    bool
    operator==(const ClearOriginParams& _o) const;

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    PersistenceType&
    persistenceType()
    {
        return persistenceType_;
    }
    const PersistenceType&
    persistenceType() const
    {
        return persistenceType_;
    }

    bool&
    persistenceTypeIsExplicit()
    {
        return persistenceTypeIsExplicit_;
    }
    const bool&
    persistenceTypeIsExplicit() const
    {
        return persistenceTypeIsExplicit_;
    }

    bool&
    clearAll()
    {
        return clearAll_;
    }
    const bool&
    clearAll() const
    {
        return clearAll_;
    }

private:
    void
    Init();

    void
    Assign(
            const PrincipalInfo& _principalInfo,
            const PersistenceType& _persistenceType,
            const bool& _persistenceTypeIsExplicit,
            const bool& _clearAll);

    PrincipalInfo principalInfo_;
    PersistenceType persistenceType_;
    bool persistenceTypeIsExplicit_;
    bool clearAll_;
};
} // namespace quota
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClearOriginsParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class ClearOriginsParams final
{
private:

public:
    MOZ_IMPLICIT ClearOriginsParams();

    MOZ_IMPLICIT ClearOriginsParams(const nsString& _pattern)
    {
        Init();
        Assign(_pattern);
    }

    MOZ_IMPLICIT ClearOriginsParams(const ClearOriginsParams& _o)
    {
        Init();
        Assign((_o).pattern());
    }

    ~ClearOriginsParams();

    void
    operator=(const ClearOriginsParams& _o)
    {
        Assign((_o).pattern());
    }

    bool
    operator==(const ClearOriginsParams& _o) const;

    nsString&
    pattern()
    {
        return pattern_;
    }
    const nsString&
    pattern() const
    {
        return pattern_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _pattern);

    nsString pattern_;
};
} // namespace quota
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClearAllParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class ClearAllParams final
{
private:

public:
    MOZ_IMPLICIT ClearAllParams()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT ClearAllParams(const ClearAllParams& _o)
    {
        Init();
        Assign();
    }

    ~ClearAllParams();

    void
    operator=(const ClearAllParams& _o)
    {
        Assign();
    }

    bool
    operator==(const ClearAllParams& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace quota
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ResetAllParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class ResetAllParams final
{
private:

public:
    MOZ_IMPLICIT ResetAllParams()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT ResetAllParams(const ResetAllParams& _o)
    {
        Init();
        Assign();
    }

    ~ResetAllParams();

    void
    operator=(const ResetAllParams& _o)
    {
        Assign();
    }

    bool
    operator==(const ResetAllParams& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace quota
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace quota {
class ClearOriginParams;
} // namespace quota
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace quota {
class ClearOriginsParams;
} // namespace quota
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace quota {
class ClearAllParams;
} // namespace quota
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace quota {
class ResetAllParams;
} // namespace quota
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union RequestParams|
//
namespace mozilla {
namespace dom {
namespace quota {
class RequestParams final
{
public:
    enum Type {
        T__None,
        TClearOriginParams = 1,
        TClearOriginsParams,
        TClearAllParams,
        TResetAllParams,
        T__Last = TResetAllParams
    };

private:
    typedef mozilla::dom::quota::ClearOriginParams ClearOriginParams;
    typedef mozilla::dom::quota::ClearOriginsParams ClearOriginsParams;
    typedef mozilla::dom::quota::ClearAllParams ClearAllParams;
    typedef mozilla::dom::quota::ResetAllParams ResetAllParams;
    typedef ClearOriginParams ClearOriginParams__tdef;
    typedef ClearOriginsParams ClearOriginsParams__tdef;
    typedef ClearAllParams ClearAllParams__tdef;
    typedef ResetAllParams ResetAllParams__tdef;

    union Value {
        mozilla::AlignedStorage2<ClearOriginParams> VClearOriginParams;
        mozilla::AlignedStorage2<ClearOriginsParams> VClearOriginsParams;
        mozilla::AlignedStorage2<ClearAllParams> VClearAllParams;
        mozilla::AlignedStorage2<ResetAllParams> VResetAllParams;
    };

    ClearOriginParams*
    ptr_ClearOriginParams()
    {
        return ((mValue).VClearOriginParams).addr();
    }
    const ClearOriginParams*
    constptr_ClearOriginParams() const
    {
        return ((mValue).VClearOriginParams).addr();
    }
    ClearOriginsParams*
    ptr_ClearOriginsParams()
    {
        return ((mValue).VClearOriginsParams).addr();
    }
    const ClearOriginsParams*
    constptr_ClearOriginsParams() const
    {
        return ((mValue).VClearOriginsParams).addr();
    }
    ClearAllParams*
    ptr_ClearAllParams()
    {
        return ((mValue).VClearAllParams).addr();
    }
    const ClearAllParams*
    constptr_ClearAllParams() const
    {
        return ((mValue).VClearAllParams).addr();
    }
    ResetAllParams*
    ptr_ResetAllParams()
    {
        return ((mValue).VResetAllParams).addr();
    }
    const ResetAllParams*
    constptr_ResetAllParams() const
    {
        return ((mValue).VResetAllParams).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT RequestParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT RequestParams(const ClearOriginParams& aOther);

    MOZ_IMPLICIT RequestParams(const ClearOriginsParams& aOther);

    MOZ_IMPLICIT RequestParams(const ClearAllParams& aOther);

    MOZ_IMPLICIT RequestParams(const ResetAllParams& aOther);

    MOZ_IMPLICIT RequestParams(const RequestParams& aOther);

    ~RequestParams();

    Type
    type() const
    {
        return mType;
    }

    RequestParams&
    operator=(const ClearOriginParams& aRhs);

    RequestParams&
    operator=(const ClearOriginsParams& aRhs);

    RequestParams&
    operator=(const ClearAllParams& aRhs);

    RequestParams&
    operator=(const ResetAllParams& aRhs);

    RequestParams&
    operator=(const RequestParams& aRhs);

    bool
    operator==(const ClearOriginParams& aRhs) const;

    bool
    operator==(const ClearOriginsParams& aRhs) const;

    bool
    operator==(const ClearAllParams& aRhs) const;

    bool
    operator==(const ResetAllParams& aRhs) const;

    bool
    operator==(const RequestParams& aRhs) const;

    ClearOriginParams&
    get_ClearOriginParams()
    {
        AssertSanity(TClearOriginParams);
        return (*(ptr_ClearOriginParams()));
    }
    const ClearOriginParams&
    get_ClearOriginParams() const
    {
        AssertSanity(TClearOriginParams);
        return (*(constptr_ClearOriginParams()));
    }
    void
    get(ClearOriginParams* aOutValue) const;
    operator ClearOriginParams&()
    {
        return get_ClearOriginParams();
    }
    operator const ClearOriginParams&() const
    {
        return get_ClearOriginParams();
    }

    ClearOriginsParams&
    get_ClearOriginsParams()
    {
        AssertSanity(TClearOriginsParams);
        return (*(ptr_ClearOriginsParams()));
    }
    const ClearOriginsParams&
    get_ClearOriginsParams() const
    {
        AssertSanity(TClearOriginsParams);
        return (*(constptr_ClearOriginsParams()));
    }
    void
    get(ClearOriginsParams* aOutValue) const;
    operator ClearOriginsParams&()
    {
        return get_ClearOriginsParams();
    }
    operator const ClearOriginsParams&() const
    {
        return get_ClearOriginsParams();
    }

    ClearAllParams&
    get_ClearAllParams()
    {
        AssertSanity(TClearAllParams);
        return (*(ptr_ClearAllParams()));
    }
    const ClearAllParams&
    get_ClearAllParams() const
    {
        AssertSanity(TClearAllParams);
        return (*(constptr_ClearAllParams()));
    }
    void
    get(ClearAllParams* aOutValue) const;
    operator ClearAllParams&()
    {
        return get_ClearAllParams();
    }
    operator const ClearAllParams&() const
    {
        return get_ClearAllParams();
    }

    ResetAllParams&
    get_ResetAllParams()
    {
        AssertSanity(TResetAllParams);
        return (*(ptr_ResetAllParams()));
    }
    const ResetAllParams&
    get_ResetAllParams() const
    {
        AssertSanity(TResetAllParams);
        return (*(constptr_ResetAllParams()));
    }
    void
    get(ResetAllParams* aOutValue) const;
    operator ResetAllParams&()
    {
        return get_ResetAllParams();
    }
    operator const ResetAllParams&() const
    {
        return get_ResetAllParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace quota
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace quota {
class PQuotaParent;
} // namespace quota
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace quota {
class PQuotaChild;
} // namespace quota
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PQuotaChild and PQuotaParent
//
namespace mozilla {
namespace dom {
namespace quota {
namespace PQuota {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::quota::PQuotaParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::quota::PQuotaChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PQuotaStart = PQuotaMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_PQuotaUsageRequestConstructor__ID,
    Reply_PQuotaUsageRequestConstructor__ID,
    Msg_PQuotaRequestConstructor__ID,
    Reply_PQuotaRequestConstructor__ID,
    Msg_StartIdleMaintenance__ID,
    Msg_StopIdleMaintenance__ID,
    PQuotaEnd
};

bool
Transition(
        mozilla::ipc::Trigger trigger,
        State* next);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_PQuotaUsageRequestConstructor(int32_t routingId);
IPC::Message*
Reply_PQuotaUsageRequestConstructor(int32_t routingId);

IPC::Message*
Msg_PQuotaRequestConstructor(int32_t routingId);
IPC::Message*
Reply_PQuotaRequestConstructor(int32_t routingId);

IPC::Message*
Msg_StartIdleMaintenance(int32_t routingId);

IPC::Message*
Msg_StopIdleMaintenance(int32_t routingId);



} // namespace PQuota
} // namespace quota
} // namespace dom
} // namespace mozilla

#endif // ifndef PQuota_h
