//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPServiceChild_h
#define PGMPServiceChild_h

#include "mozilla/gmp/PGMPService.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"


namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

// Headers for things that cannot be forward declared
#include "base/process.h"

namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPServiceChild :
    public mozilla::ipc::IToplevelProtocol
{
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPChild PGMPChild;
    typedef mozilla::gmp::PGMPParent PGMPParent;

    typedef PGMPService::State State;

    virtual PGMPContentParent*
    AllocPGMPContentParent(
            Transport* aTransport,
            ProcessId aOtherPid) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    virtual void
    ProcessingError(
            Result aCode,
            const char* aReason);
    virtual bool
    ShouldContinueFromReplyTimeout();
    virtual void
    EnteredCxxStack();
    virtual void
    ExitedCxxStack();
    virtual void
    EnteredCall();
    virtual void
    ExitedCall();

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PGMPServiceChild();

    virtual ~PGMPServiceChild();

    PGMPService::State
    state();

    bool
    SendSelectGMP(
            const nsCString& nodeId,
            const nsCString& api,
            const nsTArray<nsCString>& tags,
            uint32_t* pluginId,
            nsresult* aResult);

    bool
    SendLaunchGMP(
            const uint32_t& pluginId,
            const nsTArray<ProcessId>& alreadyBridgedTo,
            ProcessId* id,
            nsCString* displayName,
            nsresult* aResult);

    bool
    SendGetGMPNodeId(
            const nsString& origin,
            const nsString& topLevelOrigin,
            const nsString& gmpName,
            const bool& inPrivateBrowsing,
            nsCString* id);

    virtual MessageChannel*
    GetIPCChannel();
    virtual const MessageChannel*
    GetIPCChannel() const;
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

    void
    OnChannelClose();

    void
    OnChannelError();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    virtual void
    DeallocPGMPServiceChild();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    Channel mChannel;
    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPServiceChild :
    public PGMPServiceChild
{
    virtual PGMPContentParent*
    AllocPGMPContentParent(
            Transport* aTransport,
            ProcessId aOtherPid);

    MOZ_IMPLICIT GMPServiceChild();
    virtual ~GMPServiceChild();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
PGMPContentParent*
GMPServiceChild::AllocPGMPContentParent(
        Transport* aTransport,
        ProcessId aOtherPid)
{
    return 0;
}

MOZ_IMPLICIT GMPServiceChild::GMPServiceChild()
{
    MOZ_COUNT_CTOR(GMPServiceChild);
}

MOZ_IMPLICIT GMPServiceChild::~GMPServiceChild()
{
    MOZ_COUNT_DTOR(GMPServiceChild);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPServiceChild_h
