//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef IPCStream_h
#define IPCStream_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/dom/BlobTypes.h"
#include "mozilla/ipc/InputStreamParams.h"

namespace mozilla {
namespace ipc {
class InputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace dom {
class OptionalFileDescriptorSet;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct InputStreamParamsWithFds|
//
namespace mozilla {
namespace ipc {
class InputStreamParamsWithFds final
{
private:
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef mozilla::dom::OptionalFileDescriptorSet OptionalFileDescriptorSet;

public:
    MOZ_IMPLICIT InputStreamParamsWithFds();

    MOZ_IMPLICIT InputStreamParamsWithFds(
            const InputStreamParams& _stream,
            const OptionalFileDescriptorSet& _optionalFds)
    {
        Init();
        Assign(_stream, _optionalFds);
    }

    MOZ_IMPLICIT InputStreamParamsWithFds(const InputStreamParamsWithFds& _o)
    {
        Init();
        Assign((_o).stream(), (_o).optionalFds());
    }

    ~InputStreamParamsWithFds();

    void
    operator=(const InputStreamParamsWithFds& _o)
    {
        Assign((_o).stream(), (_o).optionalFds());
    }

    bool
    operator==(const InputStreamParamsWithFds& _o) const;

    InputStreamParams&
    stream()
    {
        return stream_;
    }
    const InputStreamParams&
    stream() const
    {
        return stream_;
    }

    OptionalFileDescriptorSet&
    optionalFds()
    {
        return optionalFds_;
    }
    const OptionalFileDescriptorSet&
    optionalFds() const
    {
        return optionalFds_;
    }

private:
    void
    Init();

    void
    Assign(
            const InputStreamParams& _stream,
            const OptionalFileDescriptorSet& _optionalFds);

    InputStreamParams stream_;
    OptionalFileDescriptorSet optionalFds_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class InputStreamParamsWithFds;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PSendStreamParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PSendStreamChild;
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCStream|
//
namespace mozilla {
namespace ipc {
class IPCStream final
{
public:
    enum Type {
        T__None,
        TInputStreamParamsWithFds = 1,
        TPSendStreamParent,
        TPSendStreamChild,
        T__Last = TPSendStreamChild
    };

private:
    typedef mozilla::ipc::InputStreamParamsWithFds InputStreamParamsWithFds;
    typedef mozilla::ipc::PSendStreamParent PSendStreamParent;
    typedef mozilla::ipc::PSendStreamChild PSendStreamChild;
    typedef InputStreamParamsWithFds InputStreamParamsWithFds__tdef;
    typedef PSendStreamParent* PSendStreamParent__tdef;
    typedef PSendStreamChild* PSendStreamChild__tdef;

    union Value {
        mozilla::AlignedStorage2<InputStreamParamsWithFds> VInputStreamParamsWithFds;
        mozilla::AlignedStorage2<PSendStreamParent*> VPSendStreamParent;
        mozilla::AlignedStorage2<PSendStreamChild*> VPSendStreamChild;
    };

    InputStreamParamsWithFds*
    ptr_InputStreamParamsWithFds()
    {
        return ((mValue).VInputStreamParamsWithFds).addr();
    }
    const InputStreamParamsWithFds*
    constptr_InputStreamParamsWithFds() const
    {
        return ((mValue).VInputStreamParamsWithFds).addr();
    }
    PSendStreamParent**
    ptr_PSendStreamParent()
    {
        return ((mValue).VPSendStreamParent).addr();
    }
    PSendStreamParent* const*
    constptr_PSendStreamParent() const
    {
        return ((mValue).VPSendStreamParent).addr();
    }
    PSendStreamChild**
    ptr_PSendStreamChild()
    {
        return ((mValue).VPSendStreamChild).addr();
    }
    PSendStreamChild* const*
    constptr_PSendStreamChild() const
    {
        return ((mValue).VPSendStreamChild).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCStream() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCStream(const InputStreamParamsWithFds& aOther);

    MOZ_IMPLICIT IPCStream(PSendStreamParent* aOther);

    MOZ_IMPLICIT IPCStream(PSendStreamChild* aOther);

    MOZ_IMPLICIT IPCStream(const IPCStream& aOther);

    ~IPCStream();

    Type
    type() const
    {
        return mType;
    }

    IPCStream&
    operator=(const InputStreamParamsWithFds& aRhs);

    IPCStream&
    operator=(PSendStreamParent* aRhs);

    IPCStream&
    operator=(PSendStreamChild* aRhs);

    IPCStream&
    operator=(const IPCStream& aRhs);

    bool
    operator==(const InputStreamParamsWithFds& aRhs) const;

    bool
    operator==(PSendStreamParent* aRhs) const;

    bool
    operator==(PSendStreamChild* aRhs) const;

    bool
    operator==(const IPCStream& aRhs) const;

    InputStreamParamsWithFds&
    get_InputStreamParamsWithFds()
    {
        AssertSanity(TInputStreamParamsWithFds);
        return (*(ptr_InputStreamParamsWithFds()));
    }
    const InputStreamParamsWithFds&
    get_InputStreamParamsWithFds() const
    {
        AssertSanity(TInputStreamParamsWithFds);
        return (*(constptr_InputStreamParamsWithFds()));
    }
    void
    get(InputStreamParamsWithFds* aOutValue) const;
    operator InputStreamParamsWithFds&()
    {
        return get_InputStreamParamsWithFds();
    }
    operator const InputStreamParamsWithFds&() const
    {
        return get_InputStreamParamsWithFds();
    }

    PSendStreamParent*&
    get_PSendStreamParent()
    {
        AssertSanity(TPSendStreamParent);
        return (*(ptr_PSendStreamParent()));
    }
    PSendStreamParent*
    get_PSendStreamParent() const
    {
        AssertSanity(TPSendStreamParent);
        return (*(constptr_PSendStreamParent()));
    }
    void
    get(PSendStreamParent** aOutValue) const;
    operator PSendStreamParent*&()
    {
        return get_PSendStreamParent();
    }
    operator PSendStreamParent*() const
    {
        return get_PSendStreamParent();
    }

    PSendStreamChild*&
    get_PSendStreamChild()
    {
        AssertSanity(TPSendStreamChild);
        return (*(ptr_PSendStreamChild()));
    }
    PSendStreamChild*
    get_PSendStreamChild() const
    {
        AssertSanity(TPSendStreamChild);
        return (*(constptr_PSendStreamChild()));
    }
    void
    get(PSendStreamChild** aOutValue) const;
    operator PSendStreamChild*&()
    {
        return get_PSendStreamChild();
    }
    operator PSendStreamChild*() const
    {
        return get_PSendStreamChild();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class IPCStream;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalIPCStream|
//
namespace mozilla {
namespace ipc {
class OptionalIPCStream final
{
public:
    enum Type {
        T__None,
        TIPCStream = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef mozilla::void_t void_t;
    typedef IPCStream IPCStream__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<IPCStream> VIPCStream;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    IPCStream*
    ptr_IPCStream()
    {
        return ((mValue).VIPCStream).addr();
    }
    const IPCStream*
    constptr_IPCStream() const
    {
        return ((mValue).VIPCStream).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalIPCStream() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalIPCStream(const IPCStream& aOther);

    MOZ_IMPLICIT OptionalIPCStream(const void_t& aOther);

    MOZ_IMPLICIT OptionalIPCStream(const OptionalIPCStream& aOther);

    ~OptionalIPCStream();

    Type
    type() const
    {
        return mType;
    }

    OptionalIPCStream&
    operator=(const IPCStream& aRhs);

    OptionalIPCStream&
    operator=(const void_t& aRhs);

    OptionalIPCStream&
    operator=(const OptionalIPCStream& aRhs);

    bool
    operator==(const IPCStream& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const OptionalIPCStream& aRhs) const;

    IPCStream&
    get_IPCStream()
    {
        AssertSanity(TIPCStream);
        return (*(ptr_IPCStream()));
    }
    const IPCStream&
    get_IPCStream() const
    {
        AssertSanity(TIPCStream);
        return (*(constptr_IPCStream()));
    }
    void
    get(IPCStream* aOutValue) const;
    operator IPCStream&()
    {
        return get_IPCStream();
    }
    operator const IPCStream&() const
    {
        return get_IPCStream();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef IPCStream_h
